﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class elevatorBehavior : MonoBehaviour
{
    public GameObject controller;
    public float speed;
    public int targetFloor;

    public int state;// 0 idle, 1 up, 2 down
    public GameObject load;
    private int specificFloor;
    private float floor;
    private Vector3 currPos;

    // 返回当前楼层整数
    public int GetSpecificFloor()
    {
        if ((floor - 0.1f) - specificFloor < Time.deltaTime * 15)
        {
            return specificFloor;
        }
        else
        {
            return -1;
        }
    }

    // 返回当前楼层精确数
    public float GetFloor()
    {
        return floor;
    }

    // Start is called before the first frame update
    void Start()
    {
        state = 0;
        speed = 6.0f;
        targetFloor = 2;
        currPos = GetComponent<Transform>().position;
        currPos.x = 0.1f;
        GetComponent<Transform>().position.Set(currPos.x, currPos.y, currPos.z);
        load = null;
    }

    // 更新位置信息
    private void FixedUpdate()
    {
        // 判断是否到达目标层,之后更新位置
        currPos = GetComponent<Transform>().position;

        //Debug.Log(Time.deltaTime);
        if (Mathf.Abs((targetFloor - 1) * 3.0f - floor + 0.1f) < Time.deltaTime * 15)
        {
            state = 0;
            //Debug.Log("stay");
        }
        else if ((targetFloor - 1) * 3.0f > floor)
        {
            state = 1;
            transform.Translate(Vector3.up * speed * Time.deltaTime);
            //Debug.Log("go up");
        }
        else
        {
            state = 2;
            transform.Translate(Vector3.down * speed * Time.deltaTime);
            //Debug.Log("go down");
        }
        //Debug.Log(currPos);
        floor = currPos.y;
        specificFloor = Mathf.FloorToInt(floor / 3.0f);
    }

    // Update is called once per frame
    void Update()
    {
        bool loaded = false;
        // 判断是否载重
        GameObject[] transfers = controller.GetComponent<controller>().transferVehicles;
        for (int i = 0; i < transfers.Length; i++)
        {
            Vector3 posDiff = transfers[i].GetComponent<Transform>().position - transform.position;
            
            if (Mathf.Abs(posDiff.x) < 1f && Mathf.Abs(posDiff.y) < 0.25f && Mathf.Abs(posDiff.z) < 0.5f)
            {
                //Debug.Log("eleDiff: " + posDiff);
                load = transfers[i];
                loaded = true;
            }
        }
        if (!loaded)
        {
            load = null;
        }
    }
}
